/*
 * hello.rs --
 *
 *      A rust hello world program, which uses a thread to print
 *      hello world. Build an executable using:
 *
 *      rustc -o hello -O hello.rs
 */

use std::sync::mpsc::Receiver;
use std::sync::mpsc;
use std::thread;

fn worker(rx: &Receiver<&str>) {
    for msg in rx.iter() {
        print!("{}", msg);
    }
    println!();
}

fn main() {
    let msgs = vec!["hello", " ", "world"];
    let (tx, rx) = mpsc::channel::<&str>();
    let handle = thread::spawn(move || { worker(&rx) });
    for msg in msgs {
        tx.send(msg).unwrap();
    }
    drop(tx);
    handle.join().unwrap();
}
